import asyncio

from cpl_core.logging import LoggerABC
from cpl_discord.events import OnReadyABC
from cpl_discord.service import DiscordBotServiceABC
from cpl_translation import TranslatePipe

from bot_core.abc.client_utils_service_abc import ClientUtilsServiceABC


class CoreOnReadyEvent(OnReadyABC):

    def __init__(
            self,
            logger: LoggerABC,
            bot: DiscordBotServiceABC,
            client_utils: ClientUtilsServiceABC,
            t: TranslatePipe
    ):
        OnReadyABC.__init__(self)

        self._logger = logger
        self._bot = bot
        self._client_utils = client_utils
        self._t = t

        self._logger.info(__name__, f'Module {type(self)} loaded')

    async def on_ready(self):
        self._logger.debug(__name__, f'Module {type(self)} started')
        await self._client_utils.presence_game('common.presence.booting')
        self._logger.trace(__name__, f'Module {type(self)} stopped')
