from datetime import datetime

from cpl_core.application.application_extension_abc import ApplicationExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceProviderABC
from cpl_core.logging import LoggerABC

from bot_core.configuration.feature_flags_settings import FeatureFlagsSettings


class BootLogExtension(ApplicationExtensionABC):

    def __init__(self):
        pass

    async def run(self, config: ConfigurationABC, services: ServiceProviderABC):
        feature_flags: FeatureFlagsSettings = config.get_configuration(FeatureFlagsSettings)
        if not feature_flags.boot_log_module:
            return
        logger: LoggerABC = services.get_service(LoggerABC)
        logger.debug(__name__, 'BootLog extension started')
        config.add_configuration('Bot_StartTime', str(datetime.now()))
